mov ax,013h                  ;MODE 013h
int 10h
push 0a000h                  ;on se place sur la vido
pop es

call CLS                     ;on appelle la procdure qui affiche l'image de fond

Initialisation:              ;on va crer les coordonnes de nos toiles
xor bp,bp                    ;bp sert de compteur
lea si,stars                 ;on se place sur l'adresse de STARS 
                             ;qui se trouve maintenant en DS:SI

Coordo:                      ;cette routine trouve des valeurs alatoires
                             ;pour les coordonnes X,Y,Z des toiles
                             ;X,Y,Z sont des WORDS !!!


mov dx,320                   ;valeur X maximale => 320                 
call RND                     ;on cherche un nb alatoire

mov ds:[si],dx               ;qui sort dans DX et que l'on place au premier emplacement
                             ;de ds:[si]

mov dx,200                   ;le Y => max. 200 
call RND                     ;un petit nombre alatoire
mov ds:[si+2],dx             ;qu'on place  DS:[SI+2] car on travaille avec des WORDS
                             ;(si c'tait des bytes, on aurait DS:[SI+1])

mov dx,700                   ;la taille Z est fixe, toutes les toiles sont  la mme
                             ;distance de l'observateur
mov ds:[si+4],dx             ;DS:[SI+4] car c'est un word
add si,6                     ;on augmente SI de 6 car 3 words = 6 bytes
                             ;et la plus petite valeur d'incrmentation de SI
                             ;est le byte

inc bp                       ;on dit  BP qu'on a fait une toile
cmp bp,100                   ;est-ce qu'on a nos 100 toiles ?
jna Coordo                   ;si on les a pas, on continue 


Go_Etoiles:                 
xor bp,bp                    ;BP est un compteur comme toujours
lea si,stars                 ;on se place sur les donnes des toiles    

Start:                       ;dans cette routine, on transforme les coordonnes 3D
                             ;en 2D 

mov ax,ds:[si]               ;dans AX, le X de l'toile
mov bx,ds:[si+4]             ;dans BX, le Z de l'toile
shl ax,9                     ;on multiplie AX par 512
cwd                          ;CWD ! Nombre sign
idiv bx                      ;IDIV car nombre sign
                             ; ce stade, nous avons (512*X)/Z
mov w[XT],ax                 ;c'est la position X de l'toile en 2D

mov ax,ds:[si+2]             ;on fait pareil avec Y
shl ax,9                     ;multipli par 512
cwd              
idiv bx                      ;Z est rest dans BX donc pas besoin de le recharger      
mov w[YT],ax                 ;position Y de l'toile en 2D    

add w[XT],160                ;nous devons centrer par rapport  l'cran
add w[YT],100                ;car les coordonnes taient relatives  la position (0,0)

cmp w[YT],200                ;quelques tests pour voir si le pixel ne dpasse pas de l'cran
ja No_Show                   ;YT>200 = pas de pixel
cmp w[XT],320
ja No_show                   ;XT>320 = pas de pixel

Trace:                       ;Ici, nous calculons l'offset du pixel sur l'cran
                             ;car nous n'avons que des coord. X et Y.

mov ax,w[YT]                 ;on prend Y
mov bx,320                   ;on multiplie par la largeur (Y*320)
mul bx                       ;voila...
add ax,w[XT]                 ;et on rajoute le X        
mov di,ax                    ;cet offset part chez DI qui pointe sur l'cran

mov al,14                    ;couleur 14 de la palette standard du DOS = jaune
mov es:[di],al               ;et on place le point dans la vido

No_Show:                     ;ce label se trouve l, si jamais l'toile tait en dehors
                             ;de l'cran    
in al,60h
cmp al,1                     ;test pour la touche "ESC"
jz Endo

sub ds:w[si+4],4             ;si on a pas de touche ESC, on rduit la distance de l'toile
                             ;par rapport  l'observateur
cmp ds:w[si+4],0             ;on teste si on a zro dans Z car si on fait (X/Z) avec Z=0
                             ;on obtient un DIVID ERROR (on ne peut pas diviser par 0 !!!)        

jz Restart                   ;si jamais on avait zro et bien on remet le Z de l'toile  500

Resto:                       
add si,6                     ;on augmente SI de 6 car on passe  l'toile suivante
inc bp                       ;on augmente le compteur d'toiles 
cmp bp,100                   ;on les a toutes faites ?
jz ReS                       ;alors il faut effacer l'cran avec l'image et recommencer

jmp Start                    ;autrement, on continue

Res:
call CLS                     ;la proc. CLS efface l'cran avec l'image
jmp Go_Etoiles               ;et on fait la nouvelle vague d'toiles qui est plus proche
                             ;maintenant

Endo:                        ;si on a la touche "ESC" et bien on quitte
mov ax,03h
int 10h                      ;par le mode texte et un RET qui retourne au DOS
ret

Restart:                     ;on vient voir RESTART si le Z de l'toile est gal  0     
mov ax,700                   ;on remet  700
mov ds:[si+4],ax             ;le Z de l'toile en cours de calcul
jmp Resto                    ;et on retourne d'ou on est venu



SYNC PROC                
mov dx, 3DAh
retrace1:
in al, dx
test al, 8
jz retrace1                  ;attente du retour du faisceau lumineux.
retrace2:
in al, dx
test al, 8
jnz retrace2
ret
SYNC ENDP

CLS PROC
lea si,hello
xor di,di
mov cx,32000
rep movsw
ret
CLS ENDP

RND PROC                ;voir code du feu - chapitre 9 - pour plus de commentaires                          
random: push ax                  
push dx                      
mov ax,31421               
mov bx,w[seed]
mul bx                    
add ax,6927     
mov seed,ax         
pop dx                     
mul dx                  
add dx,1
pop ax                        
ret
RND ENDP

seed    dw 0                            ;donne du crateur de nb alatoires     

include hello.db                        ;une image dans un fichier externe est
                                        ;lie  notre fichier principal

stars dw 300 dup(?)                     ;300 words (300/3=100 toiles) dont la valeur
                                        ;est (?) => inconnue


xt dw ?
yt dw ?
